
/******************************************************************************
* MODULE     : mml-config.cc
* DESCRIPTION: Obtain configuration information
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "base.hpp"
#include <string.h>
using namespace mml;

int
main (int argc, char** argv) {
  if (argc < 2) { 
    cout << "Usage: " << argv[0] << " [OPTION]\n\n";
    cout << "Available values for OPTION are:\n\n";
    cout << "  --cflags      print compiler flags\n";
    cout << "  --libs        print library linking information\n";
    cout << "  --version     print the version of the Mathemagix library\n";
  }
  else if (strcmp (argv[1], "--cflags") == 0)
    cout << CONFIG_CFLAGS << "\n";
  else if (strcmp (argv[1], "--libs") == 0)
    cout << CONFIG_LIBS << "\n";
  else if (strcmp (argv[1], "--version") == 0)
    cout << VERSION << "\n";
  return 0;
}
