
/******************************************************************************
* MODULE     : interval_ball.cpp
* DESCRIPTION: Construct an interval from its center and radius
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "interval_impl.hpp"
namespace mml {

interval
ball (dyadic_in mid, dyadic_in rad) {
  if ((abs (mid) <= (rad << MIN_SECURITY)) || has_low_prec (mid)) {
    interval r= raw_interval ();
    mpfr_sub (r->min, *mid, *rad, GMP_RNDD);
    mpfr_add (r->max, *mid, *rad, GMP_RNDU);
    return r;
  }
  else {
    interval r= raw_interval (prec (mid));
    mpfr_set (r->mid, *mid, GMP_RNDN);
    mpfr_set (r->rad, *rad, GMP_RNDU);
    return r;
  }
}

} // namespace mml
