
/******************************************************************************
* MODULE     : interval_center.cpp
* DESCRIPTION: Compute the center of an interval
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "interval_impl.hpp"
namespace mml {

dyadic
center (interval_in x) {
  if (has_low_prec (x)) {
    dyadic r (DEFAULT_LOW);
    mpfr_min (*r, x->min, x->max, GMP_RNDN);
    return r;
  }
  else {
    dyadic r (x->mid);
    mpfr_set (*r, x->mid, GMP_RNDN);
    return r;
  }
}

} // namespace mml
