
/******************************************************************************
* MODULE     : interval_shiftl.cpp
* DESCRIPTION: Shift interval to the left
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "interval_impl.hpp"
namespace mml {

interval
operator << (interval_in x, mp_exp_t shift) {
  if (is_error (x)) return x;
  interval r= raw_interval (prec (x));
  if (has_low_prec (x)) {
    mpfr_mul_2si (r->min, x->max, shift, GMP_RNDD);
    mpfr_mul_2si (r->max, x->min, shift, GMP_RNDU);
  }
  else {
    mpfr_mul_2si (r->mid, x->mid, shift, GMP_RNDN);
    CHECK_UNDERFLOW (r);
    CHECK_OVERFLOW (r);    
    mpfr_mul_2si (r->rad, x->rad, shift, GMP_RNDU);
  }
  return r;
}

} // namespace mml
