
/******************************************************************************
* MODULE     : interval_wider.cpp
* DESCRIPTION: Is the radius of an interval is larger than a given number?
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "interval_impl.hpp"
namespace mml {

bool
wider (interval_in x, dyadic_in rad) {
  if (has_low_prec (x)) {
    lp_dyadic aux;
    mpfr_rad (*aux, x->min, x->max, GMP_RNDU);
    return mpfr_cmp (*aux, *rad) >= 0;
  }
  else return mpfr_cmp (x->rad, *rad) >= 0;
}

} // namespace mml
